image: docker:stable

variables:
  #Dind setup
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

services:
  - docker:dind

stages:
  - test
  - build
  - release

build:
  stage: build
  image: golang:latest
  before_script:
    - cd uStoreAPI
  script:
    - go build -o ustore

Lint:
  stage: .pre
  image: golang:latest
  before_script:
    - go get -u golang.org/x/lint/golint
    - cd uStoreAPI
  script:
    - golint -set_exit_status $(go list ./... | grep -v /vendor/)

TUA:
  stage: test
  image: golang:latest
  before_script:
    - cd uStoreAPI
    - go get github.com/philwinder/gocoverage
    - go get github.com/mattn/goveralls
  script:
    - go test -cover ./artifact ./warehouse ./application ./common/...
    - gocoverage -ignore "base|errors|ustoreapi|vendor|\\.\\w+"
    - goveralls -coverprofile=profile.cov -service=gitlab-ci -repotoken=${COVERALLS_TOKEN}

release:
  stage: release
  only:
    - master
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - docker build -t $CI_REGISTRY_IMAGE:latest .
    - docker build -t $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID .
    - docker push $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID